// Generated by CoffeeScript 1.6.2
(function() {
  window.AngryBirdsGame = (function() {
    var PIXELS_PER_METER, contacts, forceMultiplier, frameRate, gravityX, gravityY, w;

    PIXELS_PER_METER = 30;

    gravityX = 0;

    gravityY = 10;

    frameRate = 20;

    forceMultiplier = 1.5;

    w = 0;

    contacts = [];

    function AngryBirdsGame(canvas, debugCanvas, statsCanvas) {
      var blockHeight, blockWidth, contactListener, ghost, ground, groundLevelPixels, i, j, leftPyamid, levels, myBlock, topOfPyramid, worldHeightPixels, worldWidthPixels, x, y, _i, _j, _ref,
        _this = this;

      this.world = new EaselBoxWorld(this, frameRate, canvas, debugCanvas, gravityX, gravityY, PIXELS_PER_METER);
      contactListener = new Box2D.Dynamics.b2ContactListener;
      contactListener.PostSolve = function(contact, impulse) {
        var count, i, isAPiggy, isBPiggy, maxImpulse, _i;

        console.log('UserData-A: ' + contact.GetFixtureA().GetBody().GetUserData());
        console.log('UserData-B: ' + contact.GetFixtureB().GetBody().GetUserData());
        isAPiggy = contact.GetFixtureA().GetBody().GetUserData() === 'piggy';
        isBPiggy = contact.GetFixtureB().GetBody().GetUserData() === 'piggy';
        if (contact.GetFixtureA().GetBody().GetUserData() === 'block' || contact.GetFixtureB().GetBody().GetUserData() === 'piggy') {
          count = contact.GetManifold().m_pointCount;
          console.log('count: ' + count);
          maxImpulse = 0.0;
          for (i = _i = 0; 0 <= count ? _i <= count : _i >= count; i = 0 <= count ? ++_i : --_i) {
            maxImpulse = Math.max(maxImpulse, impulse.normalImpulses[i]);
          }
          console.log('maxImpulse: ' + maxImpulse);
          if (maxImpulse > 1.0) {
            if (isAPiggy) {
              contacts.push(contact.GetFixtureA().GetBody());
            }
            if (isBPiggy) {
              return contacts.push(contact.GetFixtureB().GetBody());
            }
          }
        }
      };
      this.world.box2dWorld.SetContactListener(contactListener);
      this.stats = new Stats();
      statsCanvas.appendChild(this.stats.domElement);
      w = canvas.width;
      worldWidthPixels = canvas.width;
      worldHeightPixels = canvas.height;
      this.initHeadXPixels = 100;
      groundLevelPixels = worldHeightPixels - (37 / 2);
      this.world.addImage("/img/sky.jpg", {
        scaleX: 1.3,
        scaleY: 1.3
      });
      this.trees = this.world.addImage("/img/trees.png", {
        scaleX: 0.5,
        scaleY: 0.5,
        y: worldHeightPixels - 400 * 0.55
      });
      this.mountains = this.world.addImage("/img/mountains.png", {
        scaleX: 1,
        scaleY: 1,
        y: worldHeightPixels - 254 * 1
      });
      ground = this.world.addEntity({
        widthPixels: worldWidthPixels * 2,
        heightPixels: 37,
        type: 'static',
        friction: 0,
        xPixels: 0,
        yPixels: groundLevelPixels
      });
      this.grass = this.world.addImage("/img/ground-cropped.png", {
        scaleX: 2,
        scaleY: 2,
        y: groundLevelPixels - 37
      });
      this.world.addImage("/img/slingshot_a.png", {
        x: this.initHeadXPixels,
        y: worldHeightPixels - 160
      });
      this.head = this.world.addEntity({
        radiusPixels: 17,
        imgSrc: '/img/angry_birds_sprite.png',
        frames: {
          width: 35,
          height: 35
        },
        animations: {
          stand: [0, 0, 'stand']
        },
        startAnimation: 'stand',
        type: 'static',
        density: 2,
        friction: 1,
        bullet: true,
        xPixels: this.initHeadXPixels,
        yPixels: groundLevelPixels - 140
      });
      this.head.body.SetUserData('bird');
      this.head.selected = false;
      this.head.easelObj.onPress = function(eventPress) {
        _this.head.selected = true;
        _this.head.initPositionXpixels = eventPress.stageX;
        _this.head.initPositionYpixels = eventPress.stageY;
        eventPress.onMouseMove = function(event) {
          return _this.head.setState({
            xPixels: event.stageX,
            yPixels: event.stageY
          });
        };
        return eventPress.onMouseUp = function(event) {
          var forceX, forceY;

          _this.head.selected = false;
          _this.head.setType("dynamic");
          forceX = (_this.head.initPositionXpixels - event.stageX) * forceMultiplier;
          forceY = (_this.head.initPositionYpixels - event.stageY) * forceMultiplier;
          console.log('forceX: ' + forceX);
          console.log('forceY: ' + forceY);
          return _this.head.body.ApplyImpulse(_this.world.vector(forceX, forceY), _this.world.vector(_this.head.body.GetPosition().x, _this.head.body.GetPosition().y));
        };
      };
      this.world.addImage("/img/slingshot2_a.png", {
        x: this.initHeadXPixels - 20,
        y: worldHeightPixels - 154
      });
      blockWidth = 15;
      blockHeight = 60;
      leftPyamid = 600;
      levels = 3;
      topOfPyramid = groundLevelPixels - levels * (blockHeight + blockWidth) + 26;
      for (i = _i = 0; 0 <= levels ? _i < levels : _i > levels; i = 0 <= levels ? ++_i : --_i) {
        for (j = _j = 0, _ref = i + 1; 0 <= _ref ? _j <= _ref : _j >= _ref; j = 0 <= _ref ? ++_j : --_j) {
          x = leftPyamid + (j - i / 2) * blockHeight;
          y = topOfPyramid + i * (blockHeight + blockWidth);
          myBlock = this.world.addEntity({
            widthPixels: blockWidth,
            heightPixels: blockHeight,
            imgSrc: '/img/block1_15x60_2.png',
            xPixels: x,
            yPixels: y
          });
          myBlock.body.SetUserData('block');
          if (j <= i) {
            myBlock = this.world.addEntity({
              widthPixels: blockWidth,
              heightPixels: blockHeight,
              imgSrc: '/img/block1_15x60_2.png',
              xPixels: x + blockHeight / 2,
              yPixels: y - (blockHeight + blockWidth) / 2,
              angleDegrees: 90
            });
            myBlock.body.SetUserData('block');
            ghost = this.world.addEntity({
              widthPixels: 30,
              heightPixels: 36,
              imgSrc: '/img/badpiggy_30x36.png',
              xPixels: x + (blockHeight / 2),
              yPixels: y + 11
            });
            myBlock.body.SetUserData('piggy');
          }
        }
      }
    }

    AngryBirdsGame.prototype.tick = function() {
      var headTravel;

      this.stats.update();
      console.log('Contacts: ' + contacts.length);
      headTravel = this.head.easelObj.x - this.initHeadXPixels;
      if (headTravel > 40 && headTravel < w) {
        return this.world.easelStage.x = 0 - headTravel;
      }
    };

    return AngryBirdsGame;

  })();

}).call(this);
